Creates and hosts an instance of AtomControl available at given URL. Query string parameters from the url will be passed to view model as initial property values.

By default stack is turned off, so elements and controls will be destroyed when new control is hosted.

### Hierarchy

- AtomControl
  - AtomFrame

### Implements

- IAtomComponent<IAtomElement>
- INotifyPropertyChanged
- INotifyPropertyChanged

## Index

### Constructors

- constructor

### Properties

- app
- backCommand
- current
- currentDisposable
- defaultControlStyle
- element
- keepStack
- name
- pagePresenter
- pendingInits
- saveScrollPosition
- stack

### Accessors

- canGoBack
- controlStyle
- data
- localViewModel
- parent
- theme
- url
- viewModel

### Methods

- append
- atomParent
- beginEdit
- bind
- bindEvent
- canChange
- clearStack
- create
- dispose
- hasProperty
- invalidate
- load
- loadForReturn
- onBackCommand
- onPropertyChanged
- onUpdateSize
- onUpdateUI
- popStack
- preCreate
- push
- registerDisposable
- removeAllChildren
- resolve
- runAfterInit
- setElementClass
- setElementValue
- setLocalValue
- setPrimitiveValue
- setUrl
- toUpperCase
- unbind
- unbindEvent
- updateSize

## Constructors

### constructor

- new AtomFrame(app: App, e?: HTMLElement): AtomFrame

- Overrides AtomControl.constructor

  - Defined in web/controls/AtomFrame.ts:70

  #### Parameters

  - ##### app: App

  - ##### Optional e: HTMLElement

  #### Returns AtomFrame

## Properties

### app

app: App

Implementation of IAtomComponent.app

Inherited from AtomComponent.app

- Defined in core/AtomComponent.ts:122

### backCommand

backCommand: function

- Defined in web/controls/AtomFrame.ts:50

#### Type declaration

- - (): void

  - #### Returns void

### current

current: AtomControl

- Defined in web/controls/AtomFrame.ts:44

### currentDisposable

currentDisposable: IDisposable

- Defined in web/controls/AtomFrame.ts:48

### defaultControlStyle

defaultControlStyle: any

Inherited from AtomControl.defaultControlStyle

- Defined in web/controls/AtomControl.ts:34

### element

element: HTMLElement

Implementation of IAtomComponent.element

Inherited from AtomComponent.element

- Defined in core/AtomComponent.ts:123

### keepStack

keepStack: boolean

- Defined in web/controls/AtomFrame.ts:41

### name

name: string

- Defined in web/controls/AtomFrame.ts:38

### pagePresenter

pagePresenter: HTMLElement

- Defined in web/controls/AtomFrame.ts:46

### Protected pendingInits

pendingInits: Array<function>

Inherited from AtomComponent.pendingInits

- Defined in core/AtomComponent.ts:43

### saveScrollPosition

saveScrollPosition: boolean

- Defined in web/controls/AtomFrame.ts:52

### stack

stack: IPageItem[]

- Defined in web/controls/AtomFrame.ts:32

## Accessors

### canGoBack

- get canGoBack(): boolean

- - Defined in web/controls/AtomFrame.ts:34

  #### Returns boolean

### controlStyle

- get controlStyle(): any
- set controlStyle(v: any): void

- Inherited from AtomControl.controlStyle

  - Defined in web/controls/AtomControl.ts:37

  #### Returns any

- Inherited from AtomControl.controlStyle

  - Defined in web/controls/AtomControl.ts:73

  #### Parameters

  - ##### v: any

  #### Returns void

### data

- get data(): any
- set data(v: any): void

- Inherited from AtomComponent.data

  - Defined in core/AtomComponent.ts:52

  #### Returns any

- Inherited from AtomComponent.data

  - Defined in core/AtomComponent.ts:63

  #### Parameters

  - ##### v: any

  #### Returns void

### localViewModel

- get localViewModel(): any
- set localViewModel(v: any): void

- Inherited from AtomComponent.localViewModel

  - Defined in core/AtomComponent.ts:90

  #### Returns any

- Inherited from AtomComponent.localViewModel

  - Defined in core/AtomComponent.ts:101

  #### Parameters

  - ##### v: any

  #### Returns void

### parent

- get parent(): AtomControl

- Inherited from AtomControl.parent

  Overrides AtomComponent.parent

  - Defined in web/controls/AtomControl.ts:105

  Gets Parent AtomControl of this control.

  #### Returns AtomControl

### theme

- get theme(): AtomStyleSheet
- set theme(v: AtomStyleSheet): void

- Inherited from AtomControl.theme

  - Defined in web/controls/AtomControl.ts:92

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Returns AtomStyleSheet

- Inherited from AtomControl.theme

  - Defined in web/controls/AtomControl.ts:97

  Represents associated AtomStyleSheet with this visual hierarchy. AtomStyleSheet is inherited by default.

  #### Parameters

  - ##### v: AtomStyleSheet

  #### Returns void

### url

- get url(): string
- set url(value: string): void

- - Defined in web/controls/AtomFrame.ts:55

  #### Returns string

- - Defined in web/controls/AtomFrame.ts:58

  #### Parameters

  - ##### value: string

  #### Returns void

### viewModel

- get viewModel(): any
- set viewModel(v: any): void

- Inherited from AtomComponent.viewModel

  - Defined in core/AtomComponent.ts:69

  #### Returns any

- Inherited from AtomComponent.viewModel

  - Defined in core/AtomComponent.ts:80

  #### Parameters

  - ##### v: any

  #### Returns void

## Methods

### append

- append(element: AtomControl | HTMLElement | Text): AtomControl

- Inherited from AtomControl.append

  Overrides AtomComponent.append

  - Defined in web/controls/AtomControl.ts:138

  #### Parameters

  - ##### element: AtomControl | HTMLElement | Text

  #### Returns AtomControl

### atomParent

- atomParent(e: HTMLElement): AtomControl

- Inherited from AtomControl.atomParent

  Overrides AtomComponent.atomParent

  - Defined in web/controls/AtomControl.ts:127

  #### Parameters

  - ##### e: HTMLElement

  #### Returns AtomControl

### beginEdit

- beginEdit(): IDisposable

- Inherited from AtomComponent.beginEdit

  - Defined in core/AtomComponent.ts:368

  #### Returns IDisposable

### bind

- bind(element: HTMLElement, name: string, path: PathList[], twoWays?: boolean | string[], valueFunc?: function, source?: any): IDisposable

- Inherited from AtomComponent.bind

  - Defined in core/AtomComponent.ts:139

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### path: PathList[]

  - ##### Optional twoWays: boolean | string[]

  - ##### Optional valueFunc: function

    - - (...v: any[]): any

      - #### Parameters

        - ##### Rest ...v: any[]

        #### Returns any

  - ##### Optional source: any

  #### Returns IDisposable

### bindEvent

- bindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): IDisposable

- Inherited from AtomComponent.bindEvent

  - Defined in core/AtomComponent.ts:177

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns IDisposable

### canChange

- canChange(): Promise<boolean>

- - Defined in web/controls/AtomFrame.ts:113

  #### Returns Promise<boolean>

### Protected clearStack

- clearStack(): void

- - Defined in web/controls/AtomFrame.ts:231

  #### Returns void

### Protected create

- create(): void

- Inherited from AtomComponent.create

  - Defined in core/AtomComponent.ts:423

  #### Returns void

### dispose

- dispose(e?: HTMLElement): void

- Inherited from AtomComponent.dispose

  - Defined in core/AtomComponent.ts:316

  #### Parameters

  - ##### Optional e: HTMLElement

  #### Returns void

### hasProperty

- hasProperty(name: string): boolean

- Implementation of IAtomComponent.hasProperty

  Inherited from AtomComponent.hasProperty

  - Defined in core/AtomComponent.ts:236

  #### Parameters

  - ##### name: string

  #### Returns boolean

### invalidate

- invalidate(): void

- Inherited from AtomComponent.invalidate

  - Defined in core/AtomComponent.ts:388

  #### Returns void

### load

- load(url: AtomUri, clearHistory?: boolean): Promise<AtomControl>

- - Defined in web/controls/AtomFrame.ts:154

  #### Parameters

  - ##### url: AtomUri

  - ##### Optional clearHistory: boolean

  #### Returns Promise<AtomControl>

### Protected loadForReturn

- loadForReturn(url: AtomUri, clearHistory?: boolean): Promise<any>

- - Defined in web/controls/AtomFrame.ts:200

  #### Parameters

  - ##### url: AtomUri

  - ##### Optional clearHistory: boolean

  #### Returns Promise<any>

### onBackCommand

- onBackCommand(): Promise<void>

- - Defined in web/controls/AtomFrame.ts:76

  #### Returns Promise<void>

### onPropertyChanged

- onPropertyChanged(name: string): void

- Implementation of INotifyPropertyChanged.onPropertyChanged

  Inherited from AtomControl.onPropertyChanged

  Overrides AtomComponent.onPropertyChanged

  - Defined in web/controls/AtomControl.ts:117

  #### Parameters

  - ##### name: string

  #### Returns void

### Protected onUpdateSize

- onUpdateSize(): void

- Inherited from AtomControl.onUpdateSize

  - Defined in web/controls/AtomControl.ts:307

  #### Returns void

### onUpdateUI

- onUpdateUI(): void

- Inherited from AtomComponent.onUpdateUI

  - Defined in core/AtomComponent.ts:400

  #### Returns void

### popStack

- popStack(windowClosed?: boolean): void

- - Defined in web/controls/AtomFrame.ts:95

  This will pop page from the stack and set as current

  #### Parameters

  - ##### Optional windowClosed: boolean

    true if current page was closed by User Action

  #### Returns void

### Protected preCreate

- preCreate(): void

- Overrides AtomControl.preCreate

  - Defined in web/controls/AtomFrame.ts:244

  #### Returns void

### push

- push(ctrl: AtomControl): void

- - Defined in web/controls/AtomFrame.ts:121

  #### Parameters

  - ##### ctrl: AtomControl

  #### Returns void

### registerDisposable

- registerDisposable(d: IDisposable): IDisposable

- Inherited from AtomComponent.registerDisposable

  - Defined in core/AtomComponent.ts:412

  #### Parameters

  - ##### d: IDisposable

  #### Returns IDisposable

### Protected removeAllChildren

- removeAllChildren(e: HTMLElement): void

- Inherited from AtomControl.removeAllChildren

  - Defined in web/controls/AtomControl.ts:324

  #### Parameters

  - ##### e: HTMLElement

  #### Returns void

### Protected resolve

- resolve<TService>(c: IClassOf<TService>, selfName?: string | function): TService

- Inherited from AtomComponent.resolve

  - Defined in core/AtomComponent.ts:436

  #### Type parameters

  - #### TService

  #### Parameters

  - ##### c: IClassOf<TService>

  - ##### Optional selfName: string | function

  #### Returns TService

### runAfterInit

- runAfterInit(f: function): void

- Inherited from AtomComponent.runAfterInit

  - Defined in core/AtomComponent.ts:404

  #### Parameters

  - ##### f: function

    - - (): void

      - #### Returns void

### Protected setElementClass

- setElementClass(element: HTMLElement, value: any, clear?: boolean): void

- Inherited from AtomControl.setElementClass

  - Defined in web/controls/AtomControl.ts:269

  #### Parameters

  - ##### element: HTMLElement

  - ##### value: any

  - ##### Optional clear: boolean

  #### Returns void

### Protected setElementValue

- setElementValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomControl.setElementValue

  Overrides AtomComponent.setElementValue

  - Defined in web/controls/AtomControl.ts:164

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setLocalValue

- setLocalValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setLocalValue

  - Defined in core/AtomComponent.ts:286

  #### Parameters

  - ##### element: HTMLElement

  - ##### name: string

  - ##### value: any

  #### Returns void

### setPrimitiveValue

- setPrimitiveValue(element: HTMLElement, name: string, value: any): void

- Inherited from AtomComponent.setPrimitiveValue

  - Defined in core/AtomComponent.ts:251

  Use this method if you want to set attribute on HTMLElement immediately but defer atom control property

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement

  - ##### name: string

    string

  - ##### value: any

    any

  #### Returns void

### Protected setUrl

- setUrl(urlString: string): void

- - Defined in web/controls/AtomFrame.ts:194

  #### Parameters

  - ##### urlString: string

  #### Returns void

### toUpperCase

- toUpperCase(s: string): string

- - Defined in web/controls/AtomFrame.ts:187

  #### Parameters

  - ##### s: string

  #### Returns string

### unbind

- unbind(element: HTMLElement, name?: string): void

- Inherited from AtomComponent.unbind

  - Defined in core/AtomComponent.ts:169

  Remove all bindings associated with given element and optional name

  #### Parameters

  - ##### element: HTMLElement

    T

  - ##### Optional name: string

    string

  #### Returns void

### unbindEvent

- unbindEvent(element: HTMLElement, name?: string, method?: EventListenerOrEventListenerObject, key?: string): void

- Inherited from AtomComponent.unbindEvent

  - Defined in core/AtomComponent.ts:207

  #### Parameters

  - ##### element: HTMLElement

  - ##### Optional name: string

  - ##### Optional method: EventListenerOrEventListenerObject

  - ##### Optional key: string

  #### Returns void

### updateSize

- updateSize(): void

- Inherited from AtomControl.updateSize

  - Defined in web/controls/AtomControl.ts:147

  #### Returns void

Generated using TypeDoc